> This page is for version 2024-10-01 (default).
> For other versions, use one of these documentation indexes:
> - 2024-10-01 (default): https://docs.getkard.com/2024-10-01/llms.txt
> - Legacy: https://docs.getkard.com/legacy/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getkard.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getkard.com/_mcp/server.

# Create Attribution Events

POST https://rewards-api.getkard.com/v2/issuers/{organizationId}/users/{userId}/attributions
Content-Type: application/json

Call this endpoint to send attribution events made by a single enrolled user for processing. A maximum of 100 events can be included in a single request.

Required scopes: `attributions:write`

Reference: https://docs.getkard.com/api/attributions/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://rewards-api.getkard.com` (Production, default)
- `https://test-rewards-api.getkard.com` (Sandbox)

## Request

### Path parameters

- `organizationId` (string, required) — Your issuer organization ID, provided by Kard
- `userId` (string, required) — The ID of the user as defined on the issuers system

### Body (application/json)

This endpoint expects a CreateAttributionRequestObject.

- `data` (list of CreateAttributionRequestUnion, required) — Discriminated union representing the request body for submitting attribution events. Use `type` to distinguish between the two: - `offerAttribution`: Events related to viewing or interacting with an offer. - `notificationAttribution`: Events related to viewing or interacting with a notification.

## Response

### 202

- `data` (JobResponse, required)

## Errors

### 401 Unauthorized Error

- `errors` (list of ErrorObject, required)

### 500 Internal Server Error

- `errors` (list of ErrorObject, required)

### 400 Invalid Request

- `errors` (list of ErrorObject, required)

## Types

### CreateAttributionRequestUnion

- `type`: `offerAttribution`
  - `attributes` (OfferAttributionAttributes, required)
- `type`: `notificationAttribution`
  - `attributes` (NotificationAttributionAttributes, required)
- `type`: `placementSlotAttribution`
  - `attributes` (PlacementSlotAttributionAttributes, required) — Attributes for a slot-level activation event on a batch-activation placement. A slot activation also writes per-offer `offerAttribution` ACTIVATE events for every offer resolved by the slot's content strategy (see `ActivatePlacementSlot`).

### JobResponse

- `type` (string, required) — Type of document returned
- `id` (string, required) — The request id of the pending job
- `attributes` (Job, required)

### ErrorObject

- `status` (string, required) — Status code returned from the request
- `title` (string, required) — Name of error
- `detail` (string, required) — Description of the specific occurance of the error
- `source` (ErrorSource, optional) — An object containing a reference to the primary source of the error
- `id` (string, optional) — The id of the resource which caused the error. Always returned for multi-status errors.

### OfferAttributionAttributes

- `entityId` (string, required) — The offer ID
- `eventCode` (enum, required) — The event code of attribution event.
  - Allowed values: `IMPRESSION`, `VIEW`, `ACTIVATE`, `BOOST`
- `medium` (enum, required) — Where the offer attribution event is taking place in your rewards experience.
  - Allowed values: `BROWSE`, `EMAIL`, `MAP`, `SEARCH`, `CTA`, `PUSH`
- `eventDate` (datetime, required) — The timestamp of the attribution event. Must be in ISO 8601 format (e.g., "2025-01-01T00:00:00Z").
- `state` (AttributionState, optional) — Placement context for the attribution event

### NotificationAttributionAttributes

- `entityId` (string, required) — The notification ID
- `eventCode` (enum, required) — The event code of attribution event.
  - Allowed values: `IMPRESSION`, `VIEW`, `ACTIVATE`, `BOOST`
- `medium` (enum, required) — Where the notification attribution event is taking place in your rewards experience.
  - Allowed values: `PUSH`, `EMAIL`
- `eventDate` (datetime, required) — The timestamp of the attribution event. Must be in ISO 8601 format (e.g., "2025-01-01T00:00:00Z").
- `state` (AttributionState, optional) — Placement context for the attribution event

### PlacementSlotAttributionAttributes

Attributes for a slot-level activation event on a batch-activation placement. A slot activation also writes per-offer `offerAttribution` ACTIVATE events for every offer resolved by the slot's content strategy (see `ActivatePlacementSlot`).

- `entityId` (string, required) — The slot ID (matches `state.slotId`)
- `eventCode` (enum, required) — The event code of attribution event.
  - Allowed values: `IMPRESSION`, `VIEW`, `ACTIVATE`, `BOOST`
- `medium` (enum, required) — Where the placement-slot attribution event is taking place in your rewards experience.
  - Allowed values: `CTA`
- `eventDate` (datetime, required) — The timestamp of the attribution event. Must be in ISO 8601 format (e.g., "2025-01-01T00:00:00Z").
- `state` (AttributionState, optional) — Placement context for the attribution event

### Job

- `status` (enum, required) — Status of the job
  - Allowed values: `queued`
- `message` (string, required) — Message regarding the status of the job request

### ErrorSource

- `pointer` (string, optional) — A JSON pointer to the value in the request document that caused the error
- `parameter` (string, optional) — A string indicating which URI query parameter caused the error
- `header` (string, optional) — A string indicating the name of a single request header which caused the error

### AttributionState

- `rank` (integer, optional) — The position of the offer in the list shown to the user (1-indexed)
- `filters` (list of AttributionFilter, optional) — The active filters when the user saw the offer
- `placementId` (string, optional) — Unique identifier of the placement the attribution event originated from
- `slotId` (string, optional) — Stable identifier for the slot within the placement

### AttributionFilter

- `name` (string, required)
- `value` (string, required)

## Examples

**Request**

```json
{
  "data": [
    {
      "type": "offerAttribution",
      "attributes": {
        "entityId": "60e4ba1da31c5a22a144c075",
        "eventCode": "VIEW",
        "medium": "SEARCH",
        "eventDate": "2025-01-01T00:00:00Z"
      }
    },
    {
      "type": "offerAttribution",
      "attributes": {
        "entityId": "60e4ba1da31c5a22a144c077",
        "eventCode": "IMPRESSION",
        "medium": "EMAIL",
        "eventDate": "2025-01-01T00:00:00Z"
      }
    },
    {
      "type": "notificationAttribution",
      "attributes": {
        "entityId": "60e4ba1da31c5a22a144c076",
        "eventCode": "IMPRESSION",
        "medium": "PUSH",
        "eventDate": "2025-01-01T00:00:00Z"
      }
    }
  ]
}
```

**Response**

```json
{
  "data": {
    "type": "job",
    "id": "c94a93a7-beb9-4e58-960c-2c812f849398",
    "attributes": {
      "status": "queued",
      "message": "Attribution events are queued for processing"
    }
  }
}
```

**SDK Code**

```python
import requests

url = "https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions"

payload = { "data": [
        {
            "type": "offerAttribution",
            "attributes": {
                "entityId": "60e4ba1da31c5a22a144c075",
                "eventCode": "VIEW",
                "medium": "SEARCH",
                "eventDate": "2025-01-01T00:00:00Z"
            }
        },
        {
            "type": "offerAttribution",
            "attributes": {
                "entityId": "60e4ba1da31c5a22a144c077",
                "eventCode": "IMPRESSION",
                "medium": "EMAIL",
                "eventDate": "2025-01-01T00:00:00Z"
            }
        },
        {
            "type": "notificationAttribution",
            "attributes": {
                "entityId": "60e4ba1da31c5a22a144c076",
                "eventCode": "IMPRESSION",
                "medium": "PUSH",
                "eventDate": "2025-01-01T00:00:00Z"
            }
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":[{"type":"offerAttribution","attributes":{"entityId":"60e4ba1da31c5a22a144c075","eventCode":"VIEW","medium":"SEARCH","eventDate":"2025-01-01T00:00:00Z"}},{"type":"offerAttribution","attributes":{"entityId":"60e4ba1da31c5a22a144c077","eventCode":"IMPRESSION","medium":"EMAIL","eventDate":"2025-01-01T00:00:00Z"}},{"type":"notificationAttribution","attributes":{"entityId":"60e4ba1da31c5a22a144c076","eventCode":"IMPRESSION","medium":"PUSH","eventDate":"2025-01-01T00:00:00Z"}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions"

	payload := strings.NewReader("{\n  \"data\": [\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c075\",\n        \"eventCode\": \"VIEW\",\n        \"medium\": \"SEARCH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c077\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"EMAIL\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"notificationAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c076\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"PUSH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": [\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c075\",\n        \"eventCode\": \"VIEW\",\n        \"medium\": \"SEARCH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c077\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"EMAIL\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"notificationAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c076\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"PUSH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": [\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c075\",\n        \"eventCode\": \"VIEW\",\n        \"medium\": \"SEARCH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c077\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"EMAIL\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"notificationAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c076\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"PUSH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions', [
  'body' => '{
  "data": [
    {
      "type": "offerAttribution",
      "attributes": {
        "entityId": "60e4ba1da31c5a22a144c075",
        "eventCode": "VIEW",
        "medium": "SEARCH",
        "eventDate": "2025-01-01T00:00:00Z"
      }
    },
    {
      "type": "offerAttribution",
      "attributes": {
        "entityId": "60e4ba1da31c5a22a144c077",
        "eventCode": "IMPRESSION",
        "medium": "EMAIL",
        "eventDate": "2025-01-01T00:00:00Z"
      }
    },
    {
      "type": "notificationAttribution",
      "attributes": {
        "entityId": "60e4ba1da31c5a22a144c076",
        "eventCode": "IMPRESSION",
        "medium": "PUSH",
        "eventDate": "2025-01-01T00:00:00Z"
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": [\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c075\",\n        \"eventCode\": \"VIEW\",\n        \"medium\": \"SEARCH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"offerAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c077\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"EMAIL\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    },\n    {\n      \"type\": \"notificationAttribution\",\n      \"attributes\": {\n        \"entityId\": \"60e4ba1da31c5a22a144c076\",\n        \"eventCode\": \"IMPRESSION\",\n        \"medium\": \"PUSH\",\n        \"eventDate\": \"2025-01-01T00:00:00Z\"\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    [
      "type": "offerAttribution",
      "attributes": [
        "entityId": "60e4ba1da31c5a22a144c075",
        "eventCode": "VIEW",
        "medium": "SEARCH",
        "eventDate": "2025-01-01T00:00:00Z"
      ]
    ],
    [
      "type": "offerAttribution",
      "attributes": [
        "entityId": "60e4ba1da31c5a22a144c077",
        "eventCode": "IMPRESSION",
        "medium": "EMAIL",
        "eventDate": "2025-01-01T00:00:00Z"
      ]
    ],
    [
      "type": "notificationAttribution",
      "attributes": [
        "entityId": "60e4ba1da31c5a22a144c076",
        "eventCode": "IMPRESSION",
        "medium": "PUSH",
        "eventDate": "2025-01-01T00:00:00Z"
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rewards-api.getkard.com/v2/issuers/organization-123/users/user-123/attributions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```